package com.sf.homework;

/**
 * 信用卡类
 *
 *  * （2）声明一个银行信用卡CreditCard类，继承储蓄卡类
 *  * 增加属性：本月可透支总额度，本月已透支金额
 *  * 重写public void withdraw(double money)，可透支，
 *  * 取款金额超过账户余额+本月还可透支额度，提示超过可透支额度
 *  * 取款金额在账户余额范围内，不用透支
 *  * 取款金额超过账户余额但在可透支范围内，需要透支
 *  * 重写public void save(double money)，
 *  * 存款金额不能为负数，否则提示存款金额不能为负数
 *  * 本次存款金额只够偿还部分已透支金额
 *  * 本次存款金额除了偿还透支金额，还有剩余
 *  * （3）在测试类中，分别创建两种卡对象，测试
 *
 */
public class CreditCard extends DepositCard{
   private double maxOverdraft;  //当月可最多透支额度
   private double overdraft;   // 已经透支额度

   public void setMaxOverdraft(double maxOverdraft){
    this.maxOverdraft = maxOverdraft;
   }

   public double getMaxOverdraft(){
    return maxOverdraft;
   }

   public void setOverdraft(double overdraft){
    this.overdraft = overdraft;
   }

   public double getOverdraft(){
    return overdraft;
   }

  @Override
  public void withdraw(double money) {
   if(money > getBalance()+maxOverdraft -overdraft){
    System.out.println("超出可透支额度");
   }
   if(money <= getBalance()){
    super.withdraw(money);
   }
   overdraft += money - getBalance();
   setBalance(0);  //已经到透支   说明余额为0
  }

 @Override
 public void save(double money) {
  if(money < 0){
   System.out.println("存款金额不能为负数");
  }
  if(money <= overdraft){//有透支  需要偿还部分透支
   overdraft -= money;
  }
  //  透支已还完  还有剩余  存储到余额中
  setBalance(getBalance()+(money - overdraft));
 }


 @Override
 public String getInfo() {
  return super.getInfo()+", 本月可透支总额度："+maxOverdraft+",,本月以透支额度"+overdraft+"本月可透支"+(maxOverdraft-overdraft);
 }
}
